//
// BrokerThread.java
// created 02/18/03 by Ting Zhang
// Modified : Priyank K. Patel <pkpatel@cs.stanford.edu>
//
// Modified : Liz Stinson
//

package hotTip;

//  AWT/Swing
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// Java
import java.util.*;
import java.math.BigInteger;

// socket
import java.net.*;
import java.io.*;
import javax.net.ssl.*;

// Crypto
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public class BrokerThread extends Thread {

    //      private SSLSocket socket = null;
    private Socket socket = null;
    private Broker broker = null;
    
    private ServerSocket brokerSocket = null;
    
    private JTextArea _outputArea;
    
    InputStream is = null;
    OutputStream os = null;
    
    BufferedReader in = null;
    PrintWriter out = null;
    
    private int _portNum;
    private String _hostName;
    
    Socket sock = null;

    public BrokerThread(Broker _broker, Socket cliSock ) {
	
	super("BrokerThread");
	
	broker = _broker;

        _portNum = broker.getPortNumber();
        _outputArea = broker.getOutputArea();

        try {
            
            InetAddress serverAddr=InetAddress.getByName(null);
            _hostName = serverAddr.getHostName();

        } catch(UnknownHostException e) {
            _hostName = "0.0.0.0";
        }

	_outputArea = broker.getOutputArea();

	sock = cliSock;
    }

    public void run() {
    
	try {
	    	   
	    is = sock.getInputStream();
	    os = sock.getOutputStream();
	    
	    in = new BufferedReader(new InputStreamReader(is));
	    out = new PrintWriter(os,true);
	    
	    String receivedMsg = null;
	    
	    while ( ( receivedMsg = in.readLine() ) != null ) {
		
		_outputArea.append( "\n\nBroker received from BrokerClient: "
				    + receivedMsg );        
		
		out.println("OK");
	    }                       
	}    

	catch( Exception e ) {
	    System.err.println( e.getMessage() );
	    e.printStackTrace(); }
    }
}
